/*
 * Hormann, Leydold, Derflinger
 * Automatic Nonuniform Random Variate Generation
 * Springer, Heidelberg, New York, 2003
 * http://statistik.wu-wien.ac.at/arvag/monograph
 * 
 * Code for Algorithm 11.7 (Uniform-Ball-Rejection, p. 254)
 *
 * this file: algo11_07.c
 *
 * For a demo how to use this algorithm see the file "demo_algo11_07.c".
 *
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "uniform.h"


void generator11_07(int d, double x[])
/* 
 * Algorithm 11.7 (Uniform-Ball-Rejection, p. 254)
 * generates a random vector in the ball B^d
 * d ... length of the generated vectors
 * x ... is the array to hold the generated vector     
 */
{     int i;
      double s; 

/*1*/ do{ 
	s=0.;
	for(i=1;i<=d;i++){
/*2*/	  x[i]=uniform()*2.-1.;
	  s+=x[i]*x[i];
	}
/*3*/ }while(s>1.);
}

