/*
 * Hormann, Leydold, Derflinger
 * Automatic Nonuniform Random Variate Generation
 * Springer, Heidelberg, New York, 2003
 * http://statistik.wu-wien.ac.at/arvag/monograph
 * 
 * Code for Algorithm 12.3 (Resampling-ELK), p. 311 
 *
 * this file: algo12_03.c
 *
 * For a demo how to use this algorithm see the file "demo_algo12_03.c".
 *
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "uniform.h"

double generator12_03(double x[], int n)
/*
 * Algorithm 12.3 (Resampling-ELK), p. 311 
 *
 * x[] ... array holding the ORDERED!! sample in x[1],x[2],...,x[n]
 * n ... samplesize
 */
{       double u,v;
        int j;

/*2*/   u = uniform();
/*3*/   j = (int)((n-1.)*u+1);
        v = (n-1.)*u-j+1;
/*4+5*/ return x[j]+v*(x[j+1]-x[j]);

}





